"""
To use, either use Plone 2.0+ to install, or add an external 
method to the root of the Plone Site that you want the skin registered 
in with the configuration:

 id: install_skin
 title: Install Skin *optional*
 module name: sdotNews.Install
 function name: install

Then go to the management screen for the newly added external method
and click the 'Try it' tab.  
"""
from Products.Archetypes.public import listTypes
from Products.Archetypes.Extensions.utils import installTypes, install_subskin
from Products.sdotNews.config import *
from Products.CMFCore.utils import getToolByName

from StringIO import StringIO


ACTION_ICONS = {'plone':
                {'sdotrssfeed':('sdotrss.png','RSS feed'),
                 }
                }
                

     
def install_actions(self, out):
    ai = getToolByName(self, 'portal_actionicons')
    for category, config in ACTION_ICONS.items():
        for icon_id, info in config.items():
            if ai.queryActionIcon(category, icon_id, None) is None:
                ai.addActionIcon(category, icon_id,
                                 info[0], info[1])
                out.write("Installed action icon "
                          "for %s.\n" % info[1])
            else:
                out.write(("Action Icon for %s "
                           "was already Installed.\n"
                           % info[1]))


def install_slot(self,path,name,out):
    """ Install one slot.
    """
    done=0
    left_slots  = list(getattr(self,'left_slots'))
    right_slots = list(getattr(self,'right_slots'))
    if path not in left_slots and path not in right_slots:
        done=1
        right_slots.append(path)
        self._updateProperty('right_slots',right_slots)
        out.write('%s successfully installed\n' %(name))
    if done==0:
        out.write('%s (%s) already exists\n' %(name,path))
        
def install_slots(self,out):
    """ Install Portlet.
    """
    install_slot(self,'here/portlet_newscategories/macros/portlet','News categories portlet',out)
 
def install(self):
    out = StringIO()
    
    installTypes(self, out,
                 listTypes(PROJECTNAME),
                 PROJECTNAME)

    install_subskin(self, out, GLOBALS)
    install_slots(self,out)
    install_actions(self, out)
    
    ##
    ## Register StoreAlot as folderish content in plone, so it will
    ## get the appropriate folder_contents tabs
    props = self.portal_properties.site_properties
    tabs = getattr(props, 'use_folder_tabs')
    contents = getattr(props, 'use_folder_contents')

    if 'sdotNewsFolder' not in tabs:
        newtabs = list(tabs)
        newtabs.append('sdotNewsFolder')
        props._updateProperty('use_folder_tabs', newtabs)

    if 'sdotNewsFolder' not in contents:
        newcontents = list(contents)
        newcontents.append('sdotNewsFolder')
        props._updateProperty('use_folder_contents', newcontents)
    
    print >> out, "Successfully installed %s." % PROJECTNAME
    return out.getvalue()
